#include "spm.h"
#include "spm_value_double.h"
#include "spm_multiply.h"
#include <assert.h>

int main(int argc, char *argv[])
{
	spm_matrix *A = spm_matrix_double_alloc(2,2);
	spm_matrix *B = spm_matrix_double_alloc(2,1);
	spm_matrix *C = spm_matrix_double_alloc(2,1);
	
	spm_matrix_double_set(A, 0, 0, 1);
	spm_matrix_double_set(A, 0, 1, 2);
	spm_matrix_double_set(A, 1, 0, 0);
	spm_matrix_double_set(A, 1, 1, 3);

	spm_matrix_double_set(B, 0, 0, 1);
	spm_matrix_double_set(B, 1, 0, 10);
	
	spm_multiply_matrices(A, B, C, &spm_double_multiply_info);
	
	assert(spm_matrix_double_get(C, 0, 0) == 21);
	assert(spm_matrix_double_get(C, 1, 0) == 30);
	
	spm_matrix_free(A);
	spm_matrix_free(B);
	spm_matrix_free(C);
		
	return 0;
}