#include "spm.h"
#include "spm_value_double.h"
#include <assert.h>

int main(int argc, char *argv[])
{
	spm_matrix *m = spm_matrix_double_alloc(4,4);
	
	assert(spm_matrix_double_get(m, 0, 0) == 0);
	spm_matrix_double_set(m, 0, 0, 2.54);
	assert(spm_matrix_double_get(m, 0, 0) == 2.54);
	
	assert(spm_matrix_double_get(m, 3, 0) == 0);
	spm_matrix_double_set(m, 3, 0, 3.14159);
	assert(spm_matrix_double_get(m, 3, 0) == 3.14159);
	
	assert(spm_matrix_double_get(m, 2, 0) == 0);
	spm_matrix_double_set(m, 2, 0, 5);
	assert(spm_matrix_double_get(m, 2, 0) == 5);
	
	spm_matrix_double_set(m, 3, 0, 5);
	assert(spm_matrix_double_get(m, 3, 0) == 5);
	
	spm_matrix_double_print(m);
	
	spm_matrix_free(m);
	
	spm_vector *v = spm_vector_alloc(5, &spm_double_value_info);
	
	spm_vector_set(v, 0, &(double){82});
	spm_vector_set(v, 4, &(double){112});
	spm_vector_set(v, 2, &(double){55});
	
	double val;
	spm_vector_get(v, 1, &val);
	assert(val == 0);
	spm_vector_get(v, 0, &val);
	assert(val == 82);
	spm_vector_get(v, 4, &val);
	assert(val == 112);
	spm_vector_get(v, 2, &val);
	assert(val == 55);
	
	spm_vector_set(v, 0, &(double){0});
	
	spm_vector_get(v, 0, &val);
	assert(val == 0);
		
	return 0;
}