#include "spm.h"
#include "spm_value_double.h"
#include "spm_utils.h"
#include <assert.h>
#include <math.h>

#define EQUAL(a,b) (fabs((a)-(b))<0.0000001)

int main(int argc, char *argv[])
{
	int x,y;
	spm_matrix *m, *m2;
	
	/* This test copies a simple matrix into another matrix.
	*/

	m = spm_matrix_double_alloc(3,3);
	
	for (x=0; x<3; x++)
	{
		for (y=0; y<3; y++)
		{
			spm_matrix_double_set(m, y, x, 1+x+3*y);
		}
	}
	
	m2 = spm_matrix_double_alloc(3,3);
	spm_matrix_copy(m2, m);
	
	for (x=0; x<3; x++)
	{
		for (y=0; y<3; y++)
		{
			assert(spm_matrix_double_get(m, y, x) == spm_matrix_double_get(m2, y, x));
		}
	}
	
	spm_matrix_free(m);
	spm_matrix_free(m2);

	
	/* This next test fails, but spm_matrix_transfer_cols is unimportant, so the test does not need to pass. */
#if 0
	/*	
	This tests transfers the third, fourth, and fifth columns of the following matrix:
	
	[1  2  3  4  5  6 ]
	[2  4  6  8  10 12]
	[3  6  9  12 15 18]
	
	into another matrix. They are positioned such that the third column becomes the second column.
	
	*/
	
	m = spm_matrix_double_alloc(3,6);
	
	for (x=0; x<6; x++)
	{
		for (y=0; y<3; y++)
		{
			spm_matrix_double_set(m, y, x, (x+1)*(y+1));
		}
	}
	
	m2 = spm_matrix_double_alloc(3, 4);
	
	spm_matrix_transfer_cols(m, 2, 3, m2, 1);
	
	for (x=1; x<4; x++)
	{
		for (y=0; y<3; y++)
		{
			printf("x: %d y: %d\n", x, y);
			printf("spm_matrix_double_get: %g\n", spm_matrix_double_get(m2, y, x));
			printf("expected: %g\n", (double)((x+2)*(y+1)));
			assert(spm_matrix_double_get(m2, y, x) == (x+2)*(y+1));
		}
	}
	
	spm_matrix_free(m);
	spm_matrix_free(m2);
#endif
	
	return 0;
}